@inherits JonesComponentBase
@typeparam TItem
@using System.Runtime.CompilerServices
@using Jones.AspNetCore.Bootstrap.Types
@using Jones.AspNetCore.Utils
@implements ITable

<CascadingValue Value="@this" TValue="ITable" IsFixed>
    <CascadingValue Value="@ColumnContext" IsFixed>
        @* 初始化操作 *@
        <CascadingValue Name="IsInitialize" Value="true" IsFixed>
            @Columns(FieldModel)
        </CascadingValue>

        <table class="@TableClassName @LoadingClass">
            @ColGroup
            <thead class="@HeaderClass">
            <tr>
                <CascadingValue Name="IsHeader" Value="true" IsFixed>
                    @Columns(FieldModel)
                </CascadingValue>
            </tr>
            </thead>
            <tbody>
            @if (Items?.Any() == true)
            {
                @foreach (var item in Items)
                {
                    <tr class="@GetRowClassString(item)">
                        @Columns(item)
                    </tr>

                    if (IsHasDetails != null && Details != null && IsHasDetails(item) && !IsDetailsHidden(item))
                    {
                        <tr>
                            <td colspan="@ColumnContext.Columns.Count">
                                @Details(item)
                            </td>
                        </tr>
                    }
                }
            }
            else
            {
                <tr>
                    <td colspan="@ColumnContext.Columns.Count">
                        @EmptyStateContent
                    </td>
                </tr>
            }
            </tbody>

            @if (FooterContent != null || IsHasFooter?.Invoke() == true)
            {
                <tfoot>
                @if (IsHasFooter?.Invoke() == true)
                {
                    <tr class="@GetFooterClassString()">
                        <CascadingValue Name="IsFooter" Value="true" IsFixed>
                            @Columns(FieldModel)
                        </CascadingValue>
                    </tr>
                }
                @if (FooterContent != null)
                {
                    <CascadingValue Value="this" IsFixed="true">
                        @FooterContent
                    </CascadingValue>
                }
                </tfoot>
            }
        </table>
    </CascadingValue>
</CascadingValue>

@code {
    private static readonly TItem FieldModel = (TItem)RuntimeHelpers.GetUninitializedObject(typeof(TItem));
    
    private string? TableClassName => CssBuilder.Default("table")
        .AddClass("table-sm", TableSize == TableSize.Compact)
        .AddClass("table-center", IsCenter == true)
        .AddClass("table-bordered", IsBordered == true)
        .AddClass("table-striped", IsStriped == true)
        .AddClass("table-hover", IsHover == true)
        .AddClass($"align-{VerticalAlign?.GetDisplayName()}", VerticalAlign != null)
        .AddClassFromAttributes(AdditionalAttributes)
        .Build();
    
    /// <summary>
    /// 获得 thead 样式表集合
    /// </summary>
    protected string? HeaderClass => CssBuilder.Default()
        .AddClass(HeaderStyle?.GetDisplayName(), HeaderStyle != null)
        .Build();
    
    protected string? GetRowClassString(TItem item) => CssBuilder.Default()
        .AddClass(RowClassFormatter?.Invoke(item))
        .Build();
    
    protected string? GetFooterClassString() => CssBuilder.Default()
        .AddClass(FooterClassFormatter?.Invoke())
        .Build();
    
    public ColumnContext ColumnContext { get; set; }
    
    [Parameter]
    public RenderFragment<TItem> Columns { get; set; }
    
    [Parameter]
    public RenderFragment? ColGroup { get; set; }
    
    [Parameter]
    public Func<TItem, object>? GetKey { get; set; }
    
    [Parameter]
    public Func<TItem, bool>? IsHasDetails { get; set; }

    [Parameter]
    public bool? IsDetailsDefaultShow { get; set; }
    
    [Parameter]
    public RenderFragment<TItem>? Details { get; set; }

    private List<object> _showOrHiddenList = new();

    public void ShowOrHiddenDetails(TItem item)
    {
        if (GetKey == null)
        {
            return;
        }
        
        var key = GetKey(item);
        if (_showOrHiddenList.Contains(key))
        {
            _showOrHiddenList.Remove(key);
        }
        else
        {
            _showOrHiddenList.Add(key);
        }
    }

    public bool IsDetailsHidden(TItem item)
    {
        if (GetKey == null)
        {
            return false;
        }

        var key = GetKey(item);
        if (IsDetailsDefaultShow == true)
        {
            return _showOrHiddenList.Contains(key);
        }
        return !_showOrHiddenList.Contains(key);
    }
    
    [Parameter]
    public IEnumerable<TItem>? Items { get; set; }
    
    [Parameter]
    public bool? IsLoading { get; set; }

    private string? _loadingClass;
    [Parameter]
    public string? LoadingClass
    {
        get => IsLoading == true && Items?.Any() == true ? _loadingClass : null;
        set => _loadingClass = value;
    }
    
    /// <summary>
    /// 获得/设置 表格组件大小 默认为 Normal 正常模式
    /// </summary>
    [Parameter]
    public TableSize TableSize { get; set; }
    
    [Parameter]
    public bool? IsCenter { get; set; }
    
    /// <summary>
    /// 获得/设置 是否带边框样式 默认为 false
    /// </summary>
    [Parameter]
    public bool? IsBordered { get; set; }
    
    /// <summary>
    /// 获得/设置 是否斑马线样式 默认为 false
    /// </summary>
    [Parameter]
    public bool? IsStriped { get; set; }
    
    /// <summary>
    /// 获得/设置 是否启用悬停状态 默认为 false
    /// </summary>
    [Parameter]
    public bool? IsHover { get; set; }
    
    /// <summary>
    /// 获得/设置 内容垂直对齐方式
    /// </summary>
    [Parameter]
    public VerticalAlign? VerticalAlign { get; set; }
    
    /// <summary>
    /// 获取/设置 表格 thead 样式 <see cref="TableHeaderStyle"/>
    /// </summary>
    [Parameter]
    public TableHeaderStyle? HeaderStyle { get; set; }
    
    /// <summary>
    /// 获得/设置 行样式格式回调委托
    /// </summary>
    [Parameter]
    public Func<TItem, string?>? RowClassFormatter { get; set; }
    
    [Parameter]
    public Func<bool>? IsHasFooter { get; set; }
    
    [Parameter]
    public Func<string?>? FooterClassFormatter { get; set; }
    
    [Parameter]
    public RenderFragment? FooterContent { get; set; }
    
    [Parameter]
    public RenderFragment? EmptyStateContent { get; set; }

    protected override void OnInitialized()
    {
        base.OnInitialized();

        ColumnContext = new ColumnContext(this);
    }
}